#include <iostream>
#include <array>
#include <algorithm>
#include <numeric>
#include "NanoLogCpp17.h"
#include "Crc32.h"
#include <bits/types.h>
#include "timer.h"

// using namespace NanoLog::LogLevels;
typedef __int32_t int32_t;

typedef unsigned long int uint_fast32_t;
typedef unsigned char uint_fast8_t;

template <typename InputIterator>
inline uint_fast32_t crc(InputIterator first, InputIterator last)
{
    static auto const table = []()
    {
        auto const reversed_polynomial = uint_fast32_t{0xEDB88320uL};
        // This is a function object that calculates the checksum for a value,
        // then increments the value, starting from zero.
        struct byte_checksum
        {
            uint_fast32_t operator()() noexcept
            {
                auto checksum = static_cast<uint_fast32_t>(n++);
                for (auto i = 0; i < 8; ++i)
                    checksum = (checksum >> 1) ^ ((checksum & 0x1u) ? reversed_polynomial : 0);
                return checksum;
            }
            unsigned n = 0;
        };
        auto table = std::array<uint_fast32_t, 256>{};
        std::generate(table.begin(), table.end(), byte_checksum{});
        return table;
    }();
    // Calculate the checksum - make sure to clip to 32 bits, for systems that don't
    // have a true (fast) 32-bit type.
    return uint_fast32_t{0xFFFFFFFFuL} &
           ~std::accumulate(first, last, ~uint_fast32_t{0} & uint_fast32_t{0xFFFFFFFFuL},
                            [](uint_fast32_t checksum, std::uint_fast8_t value)
                            { return table[(checksum ^ value) & 0xFFu] ^ (checksum >> 8); });
}

int main()
{
    NanoLog::setLogFile("./performance-logs");
    NanoLog::preallocate();
    NanoLog::setLogLevel(NanoLog::NOTICE);
    timer _timer;

    std::string checksum_str[5];

    checksum_str[0] = "46414.0:0.1304:46415.0:12.797:46412.0:0.7386:46416.0:1.1386:46411.0:1.6:46417.0:2.726:46410.0:0.5969:46418.0:0.1102:46409.0:0.4942:46419.0:2.155:46408.0:2.9732:46421.0:4.5602:46407.0:5.9623:46422.0:5.1652:46406.0:1.5715:46423.0:5.4312:46405.0:1.4157:46424.0:4.1963:46404.0:1.803:46425.0:5.9334:46403.0:2.6713:46426.0:0.3959:46402.0:0.4531:46427.0:0.3706:46401.0:2.306:46428.0:2.1812:46400.0:1.7571:46429.0:0.741:46399.0:5.927:46430.0:3.6899:46398.0:4.6179:46431.0:5.7026:46397.0:3.8722:46432.0:1.1565:46396.0:0.0021:46433.0:4.0479:46395.0:0.6086:46434.0:6.2889:46394.0:5.6216:46435.0:7.0628:46393.0:1.3376:46436.0:0.8326:46392.0:0.7019:46437.0:1.5848:46391.0:5.0246:46438.0:3.1484:46390.0:5.0926:46439.0:3.1852:46389.0:1.1967:46440.0:1.9717:46388.0:3.2317:46441.0:12.1183:46387.0:1.4672:46442.0:9.8554:46386.0:1.7581:46443.0:2.7525:46385.0:0.1039:46444.0:5.0296:46384.0:0.3999:46445.0:14.2809:46383.0:26.3742:46446.0:11.7967:46382.0:3.6119:46447.0:2.2383:46381.0:6.5213:46448.0:0.5855:46380.0:4.9943:46449.0:0.2142:46379.0:0.0233:46450.0:10.0068:46377.0:0.4168:46451.0:3.987:46376.0:1.9777:46452.0:0.1104:46375.0:0.2859:46453.0:0.069:46374.0:2.362:46454.0:8.3855:46373.0:0.6411:46455.0:0.1555:46372.0:0.4207:46456.0:0.6181:46371.0:5.9523:46457.0:14.9014:46370.0:4.9571:46458.0:2.1055:46369.0:0.1141:46459.0:0.001:46368.0:1.9494:46460.0:0.5666:46367.0:0.2589:46461.0:2.145:46366.0:2.4088:46462.0:0.9664:46365.0:8.9303:46463.0:2.5058:46364.0:13.5187:46464.0:3.3128:46363.0:6.6607:46465.0:9.6165:46362.0:0.75:46466.0:4.391:46361.0:8.7745:46467.0:0.0075:46360.0:11.9129:46468.0:0.2583:46359.0:0.5516:46469.0:0.2714:46358.0:23.638:46470.0:0.8082:46357.0:1.9161:46471.0:0.2738:46356.0:1.8122:46472.0:2.7856:46355.0:5.0291:46473.0:0.248:46354.0:2.1785:46474.0:0.0716:46353.0:2.017:46475.0:17.2497:46352.0:1.8091:46477.0:2.5698:46351.0:0.001:46478.0:1.49:46350.0:1.9808:46479.0:13.2955:46348.0:0.1646:46480.0:4.0122:46347.0:0.0647:46481.0:0.2592:46346.0:0.0019:46482.0:0.4082:46345.0:0.0129:46483.0:7.4777:46344.0:0.0211:46484.0:0.004:46343.0:9.7677:46486.0:1.5337:46342.0:0.523:46487.0:7.1002:46341.0:0.025:46488.0:6.8575:46340.0:0.001:46489.0:1.8016:46339.0:16.1031:46490.0:0.2034:46337.0:4.6981:46491.0:0.6669:46336.0:0.4918:46492.0:0.0013:46333.0:0.2364:46493.0:0.428:46332.0:0.2159:46494.0:0.71:46331.0:0.4647:46495.0:0.0002:46330.0:3.8939:46496.0:8.9848:46329.0:2.41:46497.0:7.9062:46327.0:0.1785:46499.0:16.5107:46326.0:12.1381:46500.0:3.645:46325.0:3.5676:46501.0:4.3158:46323.0:0.1739:46502.0:0.2629:46322.0:0.3868:46503.0:4.4936:46321.0:0.4077:46505.0:0.02:46320.0:6.1297:46506.0:0.2321:46319.0:0.0066:46507.0:0.9933:46318.0:3.6545:46508.0:0.0204:46317.0:0.8:46509.0:0.1695:46315.0:4.9793:46510.0:5.0544:46314.0:0.583:46511.0:0.2582:46313.0:18.0973:46512.0:3.5597:46312.0:9.3371:46513.0:0.2581:46311.0:0.1739:46515.0:20.4257:46309.0:9.0701:46516.0:7.1225:46308.0:0.0066:46517.0:0.4091:46307.0:8.7968:46518.0:1.275:46306.0:0.2241:46519.0:0.26:46303.0:0.2658:46520.0:2.126";
    checksum_str[1] = "46414.0:0.1304:46415.0:12.797:46412.0:0.7386:46416.0:1.1386:46411.0:1.6:46417.0:2.726:46410.0:0.5969:46418.0:0.1102:46409.0:0.4942:46419.0:2.155:46408.0:2.9732:46421.0:4.5602:46407.0:5.9623:46422.0:5.1652:46406.0:1.5715:46423.0:5.4312:46405.0:1.4157:46424.0:4.1963:46404.0:1.803:46425.0:5.9334:46403.0:2.6713:46426.0:0.3959:46402.0:0.4531:46427.0:0.3706:46401.0:2.306:46428.0:2.1812:46400.0:1.7571:46429.0:0.741:46399.0:5.927:46430.0:3.6899:46398.0:4.6179:46431.0:5.7026:46397.0:3.8722:46432.0:1.1565:46396.0:0.0021:46433.0:4.0479:46395.0:0.6086:46434.0:6.2889:46394.0:5.6216:46435.0:7.0628:46393.0:1.3376:46436.0:0.8326:46392.0:0.7019:46437.0:1.5848:46391.0:5.0246:46438.0:3.1484:46390.0:5.0926:46439.0:3.1852:46389.0:1.1967:46440.0:1.9717:46388.0:3.2317:46441.0:12.1183:46387.0:1.4672:46442.0:9.8554:46386.0:1.7581:46443.0:2.7525:46385.0:0.1039:46444.0:5.0296:46384.0:0.3999:46445.0:14.2809:46383.0:26.3742:46446.0:11.7967:46382.0:3.6119:46447.0:2.2383:46381.0:6.5213:46448.0:0.5855:46380.0:4.9943:46449.0:0.2142:46379.0:0.0233:46450.0:10.0068:46377.0:0.4168:46451.0:3.987:46376.0:1.9777:46452.0:0.1104:46375.0:0.2859:46453.0:0.069:46374.0:2.362:46454.0:8.3855:46373.0:0.6411:46455.0:0.1555:46372.0:0.4207:46456.0:0.6181:46371.0:5.9523:46457.0:14.9014:46370.0:4.9571:46458.0:2.1055:46369.0:0.1141:46459.0:0.001:46368.0:1.9494:46460.0:0.5666:46367.0:0.2589:46461.0:2.145:46366.0:2.4088:46462.0:0.9664:46365.0:8.9303:46463.0:2.5058:46364.0:13.5187:46464.0:3.3128:46363.0:6.6607:46465.0:9.6165:46362.0:0.75:46466.0:4.391:46361.0:8.7745:46467.0:0.0075:46360.0:11.9129:46468.0:0.2583:46359.0:0.5516:46469.0:0.2714:46358.0:23.638:46470.0:0.8082:46357.0:1.9161:46471.0:0.2738:46356.0:1.8122:46472.0:2.7856:46355.0:5.0291:46473.0:0.248:46354.0:2.1785:46474.0:0.0716:46353.0:2.017:46475.0:17.2497:46352.0:1.8091:46477.0:2.5698:46351.0:0.001:46478.0:1.49:46350.0:1.9808:46479.0:13.2955:46348.0:0.1646:46480.0:4.0122:46347.0:0.0647:46481.0:0.2592:46346.0:0.0019:46482.0:0.4082:46345.0:0.0129:46483.0:7.4777:46344.0:0.0211:46484.0:0.004:46343.0:9.5837:46486.0:1.5337:46342.0:0.523:46487.0:7.1002:46341.0:0.025:46488.0:6.8575:46340.0:0.001:46489.0:1.8016:46339.0:16.1031:46490.0:0.2034:46337.0:4.6981:46491.0:0.6669:46336.0:20.9951:46492.0:0.0013:46333.0:0.2364:46493.0:0.428:46332.0:0.2159:46494.0:0.71:46331.0:0.4647:46495.0:0.0002:46330.0:3.8939:46496.0:8.9848:46329.0:2.41:46497.0:7.9062:46327.0:0.1785:46499.0:16.5107:46326.0:12.1381:46500.0:3.645:46325.0:3.5676:46501.0:4.3158:46323.0:0.1739:46502.0:0.2629:46322.0:0.3868:46503.0:4.4936:46321.0:0.4077:46505.0:0.02:46320.0:6.1297:46506.0:0.2321:46319.0:0.0066:46507.0:0.9933:46318.0:3.6545:46508.0:0.0204:46317.0:0.8:46509.0:0.1695:46315.0:4.9793:46510.0:5.0544:46314.0:0.583:46511.0:0.2582:46313.0:18.0973:46512.0:3.5597:46312.0:9.3371:46513.0:0.2581:46311.0:0.1739:46515.0:20.4257:46309.0:9.0701:46516.0:7.1225:46308.0:0.0066:46517.0:0.4091:46307.0:8.7968:46518.0:1.275:46306.0:0.2241:46519.0:0.26:46303.0:0.2658:46520.0:2.126";
    checksum_str[2] = "46414.0:0.1304:46415.0:12.797:46412.0:0.7386:46416.0:1.1386:46411.0:1.6:46417.0:2.726:46410.0:0.5969:46418.0:0.1102:46409.0:0.4942:46419.0:2.155:46408.0:2.9732:46421.0:4.5602:46407.0:5.9623:46422.0:5.1652:46406.0:1.5715:46423.0:5.4312:46405.0:1.4157:46424.0:4.1963:46404.0:1.803:46425.0:5.9334:46403.0:2.7713:46426.0:0.3959:46402.0:0.4531:46427.0:0.3706:46401.0:2.306:46428.0:2.1812:46400.0:1.7571:46429.0:0.741:46399.0:5.927:46430.0:3.6899:46398.0:4.6179:46431.0:5.7026:46397.0:3.8722:46432.0:1.1565:46396.0:0.0021:46433.0:4.0479:46395.0:0.6086:46434.0:6.2889:46394.0:5.6216:46435.0:7.0628:46393.0:1.3376:46436.0:0.8326:46392.0:0.7019:46437.0:1.5848:46391.0:5.0246:46438.0:3.1484:46390.0:5.0926:46439.0:3.1852:46389.0:1.1967:46440.0:1.9717:46388.0:3.2317:46441.0:12.1183:46387.0:1.4672:46442.0:9.8554:46386.0:1.7581:46443.0:2.7525:46385.0:0.1039:46444.0:5.0296:46384.0:0.3999:46445.0:14.2809:46383.0:26.3742:46446.0:11.7967:46382.0:3.6119:46447.0:2.2383:46381.0:6.5213:46448.0:0.5855:46380.0:4.9943:46449.0:0.2142:46379.0:0.0233:46450.0:1.7526:46377.0:0.4168:46451.0:3.987:46376.0:1.9777:46452.0:0.1104:46375.0:0.2859:46453.0:0.069:46374.0:2.362:46454.0:8.3855:46373.0:0.6411:46455.0:0.1555:46372.0:0.4207:46456.0:0.6181:46371.0:5.9523:46457.0:14.9014:46370.0:4.9571:46458.0:2.1055:46369.0:0.1141:46459.0:0.001:46368.0:1.9494:46460.0:0.5666:46367.0:0.2589:46461.0:2.145:46366.0:2.4088:46462.0:0.9664:46365.0:9.0769:46463.0:2.5058:46364.0:13.5187:46464.0:3.3128:46363.0:6.6607:46465.0:9.6165:46362.0:0.75:46466.0:4.391:46361.0:8.7745:46467.0:0.0075:46360.0:11.9129:46468.0:0.2583:46359.0:0.5516:46469.0:0.2714:46358.0:23.638:46470.0:0.8082:46357.0:1.9161:46471.0:0.2738:46356.0:1.8122:46472.0:2.7856:46355.0:5.0291:46473.0:0.248:46354.0:2.1785:46474.0:0.0716:46353.0:2.017:46475.0:17.2497:46352.0:1.8091:46477.0:2.5698:46351.0:0.001:46478.0:1.49:46350.0:1.9808:46479.0:13.2955:46348.0:0.1646:46480.0:4.0122:46347.0:0.0647:46481.0:0.2592:46346.0:0.0019:46482.0:0.4082:46345.0:0.0129:46483.0:7.4777:46344.0:0.0211:46484.0:0.004:46343.0:9.5837:46486.0:1.5337:46342.0:0.523:46487.0:7.1002:46341.0:0.025:46488.0:6.8575:46340.0:0.001:46489.0:1.8016:46339.0:16.1031:46490.0:0.2034:46337.0:4.6981:46491.0:0.6669:46336.0:20.9951:46492.0:0.0013:46333.0:0.2364:46493.0:0.428:46332.0:0.2159:46494.0:0.71:46331.0:0.4647:46495.0:0.0002:46330.0:3.8939:46496.0:8.9848:46329.0:2.41:46497.0:7.9062:46327.0:0.1785:46499.0:16.5107:46326.0:12.1381:46500.0:3.645:46325.0:3.5676:46501.0:4.3158:46323.0:0.1739:46502.0:0.2629:46322.0:0.3868:46503.0:4.4936:46321.0:0.4077:46505.0:0.02:46320.0:6.1297:46506.0:0.2321:46319.0:0.0066:46507.0:0.9933:46318.0:3.6545:46508.0:0.0204:46317.0:0.8:46509.0:0.1695:46315.0:4.9793:46510.0:5.0544:46314.0:0.583:46511.0:0.2582:46313.0:18.0973:46512.0:3.5597:46312.0:9.3371:46513.0:0.2581:46311.0:0.1739:46515.0:20.4257:46309.0:9.0701:46516.0:7.1225:46308.0:0.0066:46517.0:0.4091:46307.0:8.7968:46518.0:1.275:46306.0:0.2241:46519.0:0.26:46303.0:0.2658:46520.0:2.126";
    checksum_str[3] = "46414.0:0.1304:46415.0:12.797:46412.0:0.7386:46416.0:1.1386:46410.0:0.5969:46417.0:2.726:46409.0:0.4942:46418.0:0.1102:46408.0:2.9732:46419.0:2.155:46407.0:5.9623:46421.0:4.5602:46406.0:1.5715:46422.0:5.1652:46405.0:1.4157:46423.0:5.4312:46404.0:1.803:46424.0:4.1963:46403.0:2.7713:46425.0:5.9334:46402.0:0.4531:46426.0:0.3959:46401.0:2.306:46427.0:0.3706:46400.0:1.7571:46428.0:2.1812:46399.0:5.927:46429.0:0.741:46398.0:4.6179:46430.0:3.6899:46397.0:3.8722:46431.0:5.7026:46396.0:0.0021:46432.0:1.1565:46395.0:0.6086:46433.0:4.0479:46394.0:5.6216:46434.0:6.2808:46393.0:1.3376:46435.0:7.0628:46392.0:0.7019:46436.0:0.8326:46391.0:5.0246:46437.0:1.5848:46390.0:5.0926:46438.0:3.1484:46389.0:1.1967:46439.0:3.1852:46388.0:3.2317:46440.0:1.9717:46387.0:1.7259:46441.0:12.1183:46386.0:1.7581:46442.0:9.8554:46385.0:0.1039:46443.0:2.7525:46384.0:0.3999:46444.0:5.0296:46383.0:26.3742:46445.0:14.2809:46382.0:3.6119:46446.0:11.7967:46381.0:6.5213:46447.0:2.2383:46380.0:4.9943:46448.0:0.5855:46379.0:0.0233:46449.0:0.2142:46377.0:0.4168:46450.0:1.7526:46376.0:1.9777:46451.0:3.987:46375.0:0.2859:46452.0:0.1104:46374.0:2.362:46453.0:0.069:46373.0:0.6411:46454.0:8.3855:46372.0:0.4207:46455.0:0.1555:46371.0:5.9523:46456.0:0.6181:46370.0:4.9571:46457.0:14.9014:46369.0:0.1141:46458.0:2.1055:46368.0:1.9494:46459.0:0.001:46367.0:0.2589:46460.0:0.5666:46366.0:2.4088:46461.0:2.145:46365.0:9.0769:46462.0:0.9664:46364.0:13.5187:46463.0:2.5058:46363.0:6.6607:46464.0:3.3128:46362.0:0.75:46465.0:9.6165:46361.0:8.7745:46466.0:4.391:46360.0:11.9129:46467.0:0.0075:46359.0:0.5516:46468.0:0.2583:46358.0:23.638:46469.0:0.2714:46357.0:1.9161:46470.0:0.8082:46356.0:1.8122:46471.0:0.2738:46355.0:5.0291:46472.0:2.7856:46354.0:2.1785:46473.0:0.248:46353.0:2.017:46474.0:0.0716:46352.0:1.2092:46475.0:17.2497:46351.0:0.001:46477.0:2.5698:46350.0:1.9808:46478.0:1.49:46348.0:0.1646:46479.0:13.2955:46347.0:0.0647:46480.0:4.0122:46346.0:0.0019:46481.0:0.2592:46345.0:0.0129:46482.0:0.4082:46344.0:0.0211:46483.0:7.4777:46343.0:9.5837:46484.0:0.004:46342.0:0.523:46486.0:1.5337:46341.0:0.025:46487.0:7.1002:46340.0:0.001:46488.0:6.8575:46339.0:16.1031:46489.0:1.8016:46337.0:4.6981:46490.0:0.2034:46336.0:20.9951:46491.0:0.6669:46333.0:0.2364:46492.0:0.0013:46332.0:0.2159:46493.0:0.428:46331.0:0.4647:46494.0:0.71:46330.0:3.8939:46495.0:0.0002:46329.0:2.41:46496.0:8.9848:46327.0:0.1785:46497.0:7.9062:46326.0:12.1381:46499.0:16.5107:46325.0:3.5676:46500.0:3.645:46323.0:0.1739:46501.0:4.3158:46322.0:0.3868:46502.0:0.2629:46321.0:0.4077:46503.0:4.4936:46320.0:6.1297:46505.0:0.02:46319.0:0.0066:46506.0:0.2321:46318.0:3.6545:46507.0:0.9933:46317.0:0.8:46508.0:0.0204:46315.0:4.9793:46509.0:0.1695:46314.0:0.583:46510.0:5.0544:46313.0:18.0973:46511.0:0.2582:46312.0:9.3371:46512.0:3.5597:46311.0:0.1739:46513.0:0.2581:46309.0:9.0701:46515.0:20.4257:46308.0:0.0066:46516.0:7.1225:46307.0:8.7968:46517.0:0.4091:46306.0:0.2241:46518.0:1.275:46303.0:0.2658:46519.0:0.26:46301.0:0.0025:46520.0:2.126";
    checksum_str[4] = "46414.0:0.1304:46415.0:12.797:46412.0:0.7386:46416.0:1.1386:46410.0:2.1969:46417.0:2.726:46409.0:0.4942:46418.0:0.1102:46408.0:2.9732:46419.0:2.155:46407.0:5.9623:46421.0:4.5602:46406.0:1.5715:46422.0:5.1652:46405.0:1.4157:46423.0:5.4312:46404.0:1.803:46424.0:4.1963:46403.0:2.7713:46425.0:5.9334:46402.0:0.4531:46426.0:0.3959:46401.0:2.306:46427.0:0.3706:46400.0:1.7571:46428.0:2.1812:46399.0:5.927:46429.0:0.741:46398.0:4.6179:46430.0:3.6899:46397.0:3.8722:46431.0:5.7026:46396.0:0.0021:46432.0:1.1565:46395.0:0.6086:46433.0:4.0479:46394.0:5.6216:46434.0:6.2808:46393.0:1.3376:46435.0:7.0628:46392.0:0.7019:46436.0:0.8326:46391.0:5.0246:46437.0:1.5848:46390.0:5.0926:46438.0:3.1484:46389.0:1.1967:46439.0:3.1852:46388.0:3.2317:46440.0:1.9717:46387.0:1.7259:46441.0:12.1183:46386.0:1.7581:46442.0:9.8554:46385.0:0.1039:46443.0:2.7525:46384.0:0.3999:46444.0:5.0296:46383.0:26.3742:46445.0:14.2809:46382.0:3.6119:46446.0:11.7967:46381.0:6.5213:46447.0:2.2383:46380.0:4.9943:46448.0:0.5855:46379.0:0.0233:46449.0:0.2142:46377.0:0.4168:46450.0:1.7526:46376.0:1.9777:46451.0:3.987:46375.0:0.2859:46452.0:0.1104:46374.0:2.362:46453.0:0.069:46373.0:0.6411:46454.0:8.3855:46372.0:0.4207:46455.0:0.1555:46371.0:5.9523:46456.0:0.6181:46370.0:4.9571:46457.0:14.9014:46369.0:0.1141:46458.0:2.1055:46368.0:1.9494:46459.0:0.001:46367.0:0.2589:46460.0:0.5666:46366.0:2.4088:46461.0:2.145:46365.0:9.0769:46462.0:0.9664:46364.0:13.5187:46463.0:2.5058:46363.0:6.6607:46464.0:3.3128:46362.0:0.75:46465.0:9.6165:46361.0:8.7745:46466.0:4.391:46360.0:11.9129:46467.0:0.0075:46359.0:0.5516:46468.0:0.2583:46358.0:23.638:46469.0:0.2714:46357.0:1.9161:46470.0:0.8082:46356.0:1.8122:46471.0:0.2738:46355.0:5.0291:46472.0:2.7856:46354.0:2.1785:46473.0:0.248:46353.0:2.017:46474.0:0.0716:46352.0:1.2092:46475.0:17.2497:46351.0:0.001:46477.0:2.5698:46350.0:1.9808:46478.0:1.49:46348.0:0.1646:46479.0:13.2955:46347.0:0.0647:46480.0:4.0122:46346.0:0.0019:46481.0:0.2592:46345.0:0.0129:46482.0:0.4082:46344.0:0.2051:46483.0:7.4777:46343.0:9.5837:46484.0:0.004:46342.0:0.523:46486.0:1.5337:46341.0:0.025:46487.0:7.1002:46340.0:0.001:46488.0:6.8575:46339.0:16.1031:46489.0:1.8016:46337.0:4.6981:46490.0:0.2034:46336.0:20.9951:46491.0:0.6669:46333.0:0.2364:46492.0:0.0013:46332.0:0.2159:46493.0:0.428:46331.0:0.4647:46494.0:0.71:46330.0:3.8939:46495.0:0.0002:46329.0:2.41:46496.0:8.9848:46327.0:0.1785:46497.0:7.9062:46326.0:12.1381:46499.0:16.5107:46325.0:3.5676:46500.0:3.645:46323.0:0.1739:46501.0:4.3158:46322.0:0.3868:46502.0:0.2629:46321.0:0.4077:46503.0:4.4936:46320.0:6.1297:46505.0:0.02:46319.0:0.0066:46506.0:0.2321:46318.0:3.6545:46507.0:0.9933:46317.0:0.8:46508.0:0.0204:46315.0:4.9793:46509.0:0.1695:46314.0:0.583:46510.0:5.0544:46313.0:18.0973:46511.0:0.2582:46312.0:9.3371:46512.0:3.5597:46311.0:0.1739:46513.0:0.2581:46309.0:9.0701:46515.0:20.4257:46308.0:0.0066:46516.0:7.1225:46307.0:8.7968:46517.0:0.4091:46306.0:0.2241:46518.0:1.275:46303.0:0.2658:46519.0:0.26:46301.0:0.0025:46520.0:2.126";
    for (int i = 0; i < 1000; ++i)
    {
        for (int j = 0; j < 5; ++j)
        {
            _timer.start();
            uint_fast32_t checksum = crc(checksum_str[j].begin(), checksum_str[j].end());
            _timer.stop();
            double _time_duration = _timer.get_elapsed_ns();
            NANO_LOG(NOTICE, "Duration_func: *%0.0f", _time_duration);
            _timer.start();
            uint32_t _calculated_checksum =
                crc32_16bytes(checksum_str[j].c_str(), checksum_str[j].length());
            _timer.stop();
            _time_duration = _timer.get_elapsed_ns();
            NANO_LOG(NOTICE, "Duration_lib: *%0.0f", _time_duration);
        }
    }

    // std::cout << checksum << '\n';

    // for (int i = 0; i < 1000; i++)
    // {
    //     _timer.start();
    //     uint32_t _calculated_checksum =
    //         crc32_16bytes(checksum_str.c_str(), checksum_str.length());
    //     _timer.stop();
    //     double _time_duration = _timer.get_elapsed_ns();
    //     NANO_LOG(NOTICE, "Duration: *%0.0f", _time_duration);
    // }
    // std::cout << _calculated_checksum << '\n';

    return 0;
}